/*
 * ** SimpleTcpServer.c -- a stream socket server demo
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>

#define MAXPENDING 10



int main()
{
	int sd;
	struct sockaddr_in addr;	      /* address in sd */
	struct sockaddr_in client_addr;  /* connector's address information */
	int clientSocket;
 	unsigned int  cli_len;
	int recvMsgSize;
	char buf[50];

	/* crea una  socket di tipo TCP, */
	if ((sd = socket(PF_INET, SOCK_STREAM, 0)) == -1) {
		printf("socket failed");
		exit(1);
	}
										
	/* imposta la struttura sockaddr_in, necessaria alla bind, con l'indirizzo IP
	   del server e la porta di listening */
	
	memset(&addr,0,sizeof(addr));            /* zero fill */
	addr.sin_family = AF_INET;		
	addr.sin_port = htons(9999);	           /* short, network byte order */
	addr.sin_addr.s_addr = htonl(INADDR_ANY);/* automatically fill with my all IP */

	/* associa alla socket l'indirizzo IP e la porta di ascolto */
	if (bind(sd, (struct sockaddr *)&addr, sizeof(struct sockaddr)) == -1) {
		printf("error bind");
		exit(1);
	}

	/* server in listening; max BACKLOG richieste da processi client in coda */
	if (listen(sd, MAXPENDING) == -1) {
		printf("listen() failed");
		exit(1);
	}

	for(;;) {  /* main accept() loop */
		cli_len  = sizeof(struct sockaddr_in);
		/* il processo server blocca la sua esecuzione fino
		   alla richiesta proveniente da un client */
		if ((clientSocket = accept(sd, (struct sockaddr *)&client_addr, &cli_len)) == -1) {
			printf("accept() failed");
			continue;
		}							

		printf("server: got connection from %s\n",inet_ntoa(client_addr.sin_addr));
                if ((recvMsgSize = recv(clientSocket, buf,sizeof(buf), 0)) < 0)
	           printf("recv() failed");
		printf("server received: %s\n" ,buf);
		if (send(clientSocket, buf, recvMsgSize, 0) != recvMsgSize)

                   printf("send() error");
		
		printf("server sent  to the client:  %s\n",buf);
		close(clientSocket);
		exit(0);
       }
       return 0;
}
